var RL = 48;
var vBattery = 12;

var I1, I2, Itot;

var I1_str, I2_str, Itot_str;

var rho1, rho2;


function calculation_and_draw() {

    //99 steps gia lux


    var R4 = Number($("#num_R4").val());
    var light_level = Number($("#num_light").val());
    var rgb_level = (Math.round(1.515 * light_level + 103.485)).toString();
    var css_level = "rgb(" + rgb_level + "," + rgb_level + "," + rgb_level + ")";
    $("#canvas").css("background-color", css_level);
    $("#oer_canvas").css("background-color", css_level);

    var ldr = Math.pow(1.25 * Math.pow(10, 7) / light_level, 1 / 1.4059);
    //console.log(ldr);

    stage.removeChild(akinito);
    stage.removeChild(dromeas);
    stage.removeChild(dromtext);
    stage.removeChild(ldrvaluetext);
    stage.removeChild(Vplustext);
    stage.removeChild(Vminustext);

    var vplus = R4 * 9 / 100;
    var vminus = 22 * 9 / (44 + ldr / 1000);

    //console.log("vplus",vplus);
    //console.log("vminus",vminus);

    if (vplus >= vminus) {
        rswitch_on.visible = true;
        rswitch_off.visible = false;
        lamp_on1.visible = true;
        lamp_off1.visible = false;
    }
    else {
        rswitch_on.visible = false;
        rswitch_off.visible = true;
        lamp_on1.visible = false;
        lamp_off1.visible = true;
    }

    Vplustext = new createjs.Text("","20px Arial", "black");
    Vminustext = new createjs.Text("","20px Arial", "black");
    Vplustext.x = 388;
    Vplustext.y = 470;
    Vplustext.text = "V+ = " + vplus.toFixed(2) + "V";

    
    Vminustext.text = "V-  = " + vminus.toFixed(2) + "V";
    Vminustext.x = 388;
    Vminustext.y = 505;

    

    stage.addChild(Vplustext);
    stage.addChild(Vminustext);

    if (vplus>7.5){
        unacceptable_text1.visible=true;
        unacceptable_text2.visible=true;
        
    }
    else{
        unacceptable_text1.visible=false;
        unacceptable_text2.visible=false;
    }

    akinito = new createjs.Shape();
    dromeas = new createjs.Shape();
    dromtext = new createjs.Text("Δ", "10px Arial", "black");
    ldrvaluetext = new createjs.Text();
    ldrvaluetext.font = "17px Arial";
    ldrvaluetext.color = "black";
    ldrvaluetext.text = "R  =" + (ldr / 1000).toFixed(1) + "kΩ";
    ldrvaluetext.x = 170 - 20;
    ldrvaluetext.y = 100;
    stage.addChild(ldrvaluetext);


    akinito.graphics.beginStroke("black").moveTo(300, 238).lineTo(285, 238).lineTo(285, -0.93 * R4 + 368 - 5);
    stage.addChild(akinito);


    dromeas.x = 244;
    dromeas.y = -0.93 * R4 + 368; //start=275px, end=368px-->365px-->0kΩ, 275px-->100kΩ  d=a*R+b --> 365=b, 275=100a+365 --> a=-0.9 --> dromeas.y=-0.9*R+365
    //R4initial=RΑΔ=75kΩ 
    dromeas.graphics.beginFill("gold").drawCircle(0, 0, 3).endFill();
    dromeas.graphics.beginFill("blue").moveTo(3, 0).lineTo(13, -10).lineTo(13, 10).lineTo(3, 0).endFill();
    dromeas.graphics.beginFill("blue").drawRect(13, -5, 29, 10);
    stage.addChild(dromeas);


    dromtext.x = 254;
    dromtext.y = dromeas.y - 5;
    stage.addChild(dromtext);


    stage.update();

}