var stage = new createjs.Stage("canvas");
createjs.Touch.enable(stage);
stage.enableMouseOver();

var queue = new createjs.LoadQueue();
var counter = 0;
var count = 0
var c = 1;

var lamp_on1, lamp_off1, amp, amp1, amp2, batt, drom1, kin_l;

var lamp_on1 = new createjs.Shape();
var lamp_off1 = new createjs.Shape();



var dromeas = new createjs.Shape();
var dromtext = new createjs.Text("Δ", "10px Arial", "black");
var akinito = new createjs.Shape();
var rswitch_on = new createjs.Shape();
var rswitch_off = new createjs.Shape();
var initial_LDR = Math.pow(1.25 * Math.pow(10, 7) / 42, 1 / 1.4059) / 1000;
console.log("initial LDR",initial_LDR);

var ldrvaluetext = new createjs.Text();
ldrvaluetext.text = "R  =" + initial_LDR.toFixed(1) + "kΩ";
ldrvaluetext.font = "17px Arial";
ldrvaluetext.color = "black";



var res_rect = new createjs.Shape();
res_rect.x = 328;
res_rect.y = 440;
res_rect.graphics.beginFill("#657b16").drawRoundRect(0, 0, 230, 130, 7);
stage.addChild(res_rect);

var unacceptable_text1=new createjs.Text("Απρόβλεπτη συμπεριφορά ","17px Arial","black");
unacceptable_text1.x=337;
unacceptable_text1.y=528;
stage.addChild(unacceptable_text1);
unacceptable_text1.visible=false;

var unacceptable_text2=new createjs.Text("τελεστικού ενισχυτή","17px Arial","black");
unacceptable_text2.x=367;
unacceptable_text2.y=543;
stage.addChild(unacceptable_text2);
unacceptable_text2.visible=false;

var vplusini = 37 * 9 / 100;
var vminusini = 22 * 9 / (44 + initial_LDR);
console.log(vminusini);

var Btext=new createjs.Text("B","20px Arial","black");
Btext.x=238;
Btext.y=251;
stage.addChild(Btext);

var relaytext1=new createjs.Text("ηλεκτρομηχανικό","12px Arial","black");
relaytext1.x=501;
relaytext1.y=25;

stage.addChild(relaytext1);

var relaytext2=new createjs.Text("ρελέ","15px Arial","black");
relaytext2.x=501;
relaytext2.y=35;

stage.addChild(relaytext2)


var opamprestext = new createjs.Text("είσοδοι τελεστικού ενισχυτή", "17px Arial", "white");
opamprestext.x = 340;
opamprestext.y = 445;
stage.addChild(opamprestext)

var Vplustext = new createjs.Text("", "20px Arial", "black");
Vplustext.text = "V+ = " + vplusini.toFixed(2) + "V";
Vplustext.x = 388;
Vplustext.y = 470;

var Vminustext = new createjs.Text("", "20px Arial", "black");
Vminustext.text = "V-  = " + vminusini.toFixed(2) + "V";
Vminustext.x = 388;
Vminustext.y = 505;

stage.addChild(Vplustext);
stage.addChild(Vminustext);



$("#num_light").val(42);
$("#light_slider").val(42);

var rgb_level = (Math.round(1.515 * 42 + 103.485)).toString();
var css_level = "rgb(" + rgb_level + "," + rgb_level + "," + rgb_level + ")";
$("#canvas").css("background-color", css_level);
$("#oer_canvas").css("background-color", css_level);
$("#num_R4").val(37);
$("#R4_slider").val(37);



queue.on("complete", handleComplete);
queue.on("fileload", handleFileLoad);
queue.loadManifest([
    { id: "lamp_on", src: "images/lamp-on.png" },
    { id: "lamp_off", src: "images/lamp-off.png" },
    { id: "battery", src: "images/battery.png" }
]);


function handleFileLoad(event) {
    count += 1
    console.log("asset " + count + " loaded");
}
function handleComplete(event) {

    lamp_on1 = new createjs.Bitmap(queue.getResult("lamp_on"));
    lamp_on1.x = 585;
    lamp_on1.y = 130;
    lamp_on1.scaleX = lamp_on1.scaleY = 0.30;

    lamp_off1 = new createjs.Bitmap(queue.getResult("lamp_off"));
    lamp_off1.x = 584.5;
    lamp_off1.y = 129.8;
    lamp_off1.scaleX = lamp_off1.scaleY = 0.30;


    batt = new createjs.Bitmap(queue.getResult("battery"));
    batt.x = 13;
    batt.y = 180;
    batt.scaleX = batt.scaleY = 0.8
    stage.addChild(batt);



    Rpot = new createjs.Shape();
    Rpot.x = 229;
    Rpot.y = 275;
    Rpot.graphics.beginStroke("black").setStrokeStyle(3).moveTo(0, 0).lineTo(6, -12).lineTo(18, 12).lineTo(30, -12).lineTo(42, 12).lineTo(56, -12).lineTo(68, 12).lineTo(80, -12).lineTo(92, 12).lineTo(104, -12).lineTo(116, 12).lineTo(128, -12).lineTo(134, 0);
    stage.addChild(Rpot);

    Rpot.scaleX = 0.7;
    Rpot.scaleY = 0.8;
    Rpot.rotation = 90;

    var ldr = new createjs.Shape();
    ldr.x = 185 - 40 - 20;
    ldr.y = 85 - 20 - 10;
    ldr.graphics.beginStroke("black").setStrokeStyle(3).moveTo(0, 0).lineTo(6, -12).lineTo(18, 12).lineTo(30, -12).lineTo(42, 12).lineTo(56, -12).lineTo(68, 12).lineTo(80, -12).lineTo(86, 0);

    ldr.scaleX = 0.6;
    ldr.scaleY = 0.8;
    ldr.rotation = 90;

    stage.addChild(ldr);

    var circle_arrows = new createjs.Shape();
    circle_arrows.x = 185 - 40 - 20;
    circle_arrows.y = 111 - 20 - 10;
    circle_arrows.graphics.beginStroke("black").drawCircle(0, 0, 28);
    stage.addChild(circle_arrows);

    var arrow1 = new createjs.Shape()
    arrow1.graphics.beginStroke("black").moveTo(232 - 40 - 20, 60 - 20 - 10).lineTo(210 - 40 - 20, 83 - 20 - 10).moveTo(210 - 40 - 20, 83 - 20 - 10).lineTo(211 - 40 - 20, 72 - 20 - 10).moveTo(210 - 40 - 20, 83 - 20 - 10).lineTo(221 - 40 - 20, 61 - 10);
    stage.addChild(arrow1);

    var arrow2 = new createjs.Shape()
    arrow2.graphics.beginStroke("black").moveTo(246 - 40 - 20, 75 - 20 - 10).lineTo(227 - 40 - 20, 96 - 20 - 10).moveTo(227 - 40 - 20, 96 - 20 - 10).lineTo(228 - 40 - 20, 85 - 20 - 10).moveTo(227 - 40 - 20, 96 - 20 - 10).lineTo(238 - 40 - 20, 93 - 20 - 10);
    stage.addChild(arrow2);

    var R1 = new createjs.Shape();
    R1.x = 185 - 40 - 20;
    R1.y = 155 - 20 - 10;
    R1.graphics.beginStroke("black").setStrokeStyle(3).moveTo(0, 0).lineTo(6, -12).lineTo(18, 12).lineTo(30, -12).lineTo(42, 12).lineTo(56, -12).lineTo(68, 12).lineTo(80, -12).lineTo(86, 0);
    R1.scaleX = 0.6;
    R1.scaleY = 0.8;
    R1.rotation = 90;
    stage.addChild(R1);

    var R2 = new createjs.Shape();
    R2.x = 185 - 40 - 20;
    R2.y = 275;
    R2.graphics.beginStroke("black").setStrokeStyle(3).moveTo(0, 0).lineTo(6, -12).lineTo(18, 12).lineTo(30, -12).lineTo(42, 12).lineTo(56, -12).lineTo(68, 12).lineTo(80, -12).lineTo(86, 0);
    R2.scaleX = 0.6;
    R2.scaleY = 0.8;
    R2.rotation = 90;
    stage.addChild(R2);

    var amplifier = new createjs.Shape();
    amplifier.x = 300;
    amplifier.y = 170;
    amplifier.graphics.beginStroke("black").moveTo(0, 0).lineTo(0, 90).moveTo(0, 0).lineTo(45, 45).lineTo(0, 90);
    amplifier.graphics.beginStroke("black").moveTo(3, 20).lineTo(12, 20);
    amplifier.graphics.beginStroke("black").moveTo(3, 67).lineTo(12, 67);
    amplifier.graphics.beginStroke("black").moveTo(7, 63).lineTo(7, 71);
    stage.addChild(amplifier);

    var R3 = new createjs.Shape();
    R3.x = 375;
    R3.y = 225 - 9;
    R3.graphics.beginStroke("black").setStrokeStyle(3).moveTo(0, 0).lineTo(6, -12).lineTo(18, 12).lineTo(30, -12).lineTo(42, 12).lineTo(56, -12).lineTo(68, 12).lineTo(80, -12).lineTo(86, 0);
    R3.scaleX = 0.6;
    R3.scaleY = 0.8;
    //R2.rotation = 90;
    stage.addChild(R3);

    var R3text = new createjs.Text("R3", "17px Arial", "black");
    R3text.x = 384;
    R3text.y = 180;
    stage.addChild(R3text);

    var R1text = new createjs.Text("R =22kΩ", "17px Arial", "black");
    R1text.x = 165 - 20 - 5;
    R1text.y = 140;
    stage.addChild(R1text);

    var R1text1 = new createjs.Text("1", "11px Arial", "black");
    R1text1.x = 151;
    R1text1.y = 148;
    stage.addChild(R1text1);

    var R2text = new createjs.Text("R =22kΩ", "17px Arial", "black");
    R2text.x = 165 - 20 - 5;
    R2text.y = 292;
    stage.addChild(R2text);

    var R2text2 = new createjs.Text("2", "11px Arial", "black");
    R2text2.x = 151;
    R2text2.y = 300;
    stage.addChild(R2text2);



    var npn = new createjs.Shape();
    npn.x = 449;
    npn.y = 225 - 9;
    npn.graphics.beginStroke("black").drawCircle(0, 0, 3).moveTo(3, 0).lineTo(27, 0).beginStroke("black").setStrokeStyle(3).moveTo(27, 0).lineTo(27, -20).moveTo(27, 0).lineTo(27, 20).setStrokeStyle(1).moveTo(27, -8).lineTo(43, -20).lineTo(43, -30).moveTo(27, 8).lineTo(43, 20).moveTo(43, 20).lineTo(42, 10).moveTo(43, 20).lineTo(34, 20).moveTo(43, 20).lineTo(43, 32);
    npn.graphics.beginStroke("black").drawCircle(43, 35, 3);
    npn.graphics.beginStroke("black").drawCircle(43, -33, 3);
    stage.addChild(npn);

    var basetext = new createjs.Text("B", "19px Arial", "black");
    basetext.x = 445;
    basetext.y = 190;
    stage.addChild(basetext);

    var collectortext = new createjs.Text("C", "19px Arial", "black");
    collectortext.x = 472;
    collectortext.y = 167;
    stage.addChild(collectortext);

    var emittertext = new createjs.Text("E", "19px Arial", "black");
    emittertext.x = 469;
    emittertext.y = 255;
    stage.addChild(emittertext);

    var positive = new createjs.Shape();
    positive.x = 62;
    positive.y = 182;
    positive.graphics.beginStroke("red").setStrokeStyle(2).moveTo(0, 0).lineTo(0, -165).lineTo(85 - 20, -165).lineTo(85 - 20, -129).moveTo(85 - 20, -165).lineTo(265, -165).lineTo(265, 15).moveTo(265, -165).lineTo(430, -165).lineTo(430, -140);
    stage.addChild(positive);

    var negative = new createjs.Shape();
    negative.x = 30;
    negative.y = 182;
    negative.graphics.beginStroke("black").setStrokeStyle(2).moveTo(0, 0).lineTo(0, -40).lineTo(-25, -40).lineTo(-25, 230).lineTo(462, 230).lineTo(462, 82 - 9).moveTo(297, 230).lineTo(297, 52);
    stage.addChild(negative);

    var lm358 = new createjs.Text("LM358", "11px Arial", "black");
    lm358.x = 306;
    lm358.y = 210;
    stage.addChild(lm358);

    var line1 = new createjs.Shape();
    line1.graphics.beginStroke("black").moveTo(147 - 20, 106).lineTo(147 - 20, 125);
    line1.graphics.beginStroke("black").moveTo(147 - 20, 177).lineTo(147 - 20, 276);

    stage.addChild(line1);

    var line2 = new createjs.Shape();
    line2.graphics.beginFill("black").drawCircle(147 - 20, 189, 3).endFill().beginStroke("black").moveTo(150 - 20, 189).lineTo(300, 189).moveTo(147 - 20, 325).lineTo(147 - 20, 413);
    stage.addChild(line2);

    var line3 = new createjs.Shape();
    line3.graphics.beginStroke("red").moveTo(230, 18).lineTo(230, 179);
    line3.graphics.beginStroke("red").arc(230, 189, 10, -Math.PI / 2, Math.PI / 2);
    line3.graphics.beginStroke("red").moveTo(230, 199).lineTo(230, 277).beginStroke("black").moveTo(230, 370).lineTo(230, 411);
    stage.addChild(line3);


    akinito.graphics.beginStroke("black").moveTo(300, 238).lineTo(285, 238).lineTo(285, -0.93 * 37 + 368 - 5);
    stage.addChild(akinito);


    dromeas.x = 244;
    dromeas.y = -0.93 * 37 + 368; //start=275px, end=368px-->365px-->0kΩ, 275px-->100kΩ  d=a*R+b --> 368=b, 275=100a+368 --> a=-0.9 --> dromeas.y=-0.93*R+368
    //R4initial=RΑΔ=75kΩ 
    dromeas.graphics.beginFill("gold").drawCircle(0, 0, 3).endFill();
    dromeas.graphics.beginFill("blue").moveTo(3, 0).lineTo(13, -10).lineTo(13, 10).lineTo(3, 0).endFill();
    dromeas.graphics.beginFill("blue").drawRect(13, -5, 29, 10);
    stage.addChild(dromeas);


    dromtext.x = 254;
    dromtext.y = dromeas.y - 5;
    stage.addChild(dromtext);

    var AlphaText = new createjs.Text("A", "19px Arial", "black");
    AlphaText.x = 242;
    AlphaText.y = 373;
    stage.addChild(AlphaText);
    //---------------------------------------------------------------------------------------------------------------

    var relay = new createjs.Shape();
    relay.x = 492;
    relay.y = 41;
    relay.graphics.beginStroke("black").moveTo(0, 0).lineTo(0, 15);
    relay.graphics.beginStroke("black").arc(0, 25, 10, -Math.PI / 2, Math.PI / 2);
    relay.graphics.beginStroke("black").arc(0, 45, 10, -Math.PI / 2, Math.PI / 2);
    relay.graphics.beginStroke("black").arc(0, 65, 10, -Math.PI / 2, Math.PI / 2);
    relay.graphics.beginStroke("black").arc(0, 85, 10, -Math.PI / 2, Math.PI / 2);

    relay.graphics.beginStroke("black").moveTo(17, 18).lineTo(17, 92);
    relay.graphics.beginStroke("black").moveTo(23, 18).lineTo(23, 92);

    relay.graphics.beginStroke("black").moveTo(30, 45).lineTo(75, 45).endStroke().beginStroke("black").drawCircle(78, 45, 3);
    relay.graphics.beginStroke("black").moveTo(30, 45).lineTo(35, 51).lineTo(40, 45);
    relay.graphics.beginStroke("black").moveTo(52, 68).lineTo(75, 68).endStroke().beginStroke("black").drawCircle(78, 68, 3);;

    stage.addChild(relay);

    rswitch_off.x = 544;
    rswitch_off.y = 109;
    rswitch_off.graphics.beginStroke("orange").setStrokeStyle(3).moveTo(0, 0).lineTo(-22, 0);
    stage.addChild(rswitch_off);

    rswitch_on.x = 544;
    rswitch_on.y = 109;
    rswitch_on.graphics.beginStroke("orange").setStrokeStyle(3).moveTo(0, 0).lineTo(-17, -17);
    stage.addChild(rswitch_on);


    var line4 = new createjs.Shape();
    line4.graphics.beginStroke("black").moveTo(492, 136).lineTo(492, 180);
    stage.addChild(line4);

    var phasetext = new createjs.Text("L", "19px Arial", "brown");
    phasetext.x = 599;
    phasetext.y = 10;
    stage.addChild(phasetext);

    var phase = new createjs.Shape();
    phase.graphics.beginStroke("brown").setStrokeStyle(3).moveTo(620, 10).lineTo(620, 86).lineTo(573, 86).moveTo(590, 86).moveTo(570, 112).lineTo(570, 240).lineTo(603, 240);
    stage.addChild(phase);

    var oudet = new createjs.Shape();
    oudet.graphics.beginStroke("blue").setStrokeStyle(3).moveTo(620, 255).lineTo(620, 285).lineTo(680, 285).lineTo(680, 10);
    stage.addChild(oudet);

    var oudettext = new createjs.Text("N", "19px Arial", "blue");
    oudettext.x = 656;
    oudettext.y = 10;
    stage.addChild(oudettext);





    var Vbat = new createjs.Text("U=9V");
    Vbat.font = "22px Arial";
    Vbat.x = 20;
    Vbat.y = 329;
    stage.addChild(Vbat);

    var batteryplustext = new createjs.Text("+", "19px Arial", "black");
    batteryplustext.x = 55;
    batteryplustext.y = 200;
    stage.addChild(batteryplustext);

    var batteryminustext = new createjs.Text("-", "19px Arial", "black");
    batteryminustext.x = 26;
    batteryminustext.y = 200;
    stage.addChild(batteryminustext);

    var ampltores = new createjs.Shape();
    ampltores.x = 345;
    ampltores.y = 225 - 9;
    ampltores.graphics.beginStroke("black").moveTo(0, 0).lineTo(30, 0);
    stage.addChild(ampltores);

    var restotransistor = new createjs.Shape();
    restotransistor.x = 425;
    restotransistor.y = 225 - 9;
    restotransistor.graphics.beginStroke("black").moveTo(0, 0).lineTo(22, 0);
    stage.addChild(restotransistor);

    ldrvaluetext.x = 170 - 20;
    ldrvaluetext.y = 100;
    stage.addChild(ldrvaluetext);

    var ldrtext = new createjs.Text("LDR", "8px Arial", "black");
    ldrtext.x = 162;
    ldrtext.y = 114;
    stage.addChild(ldrtext);

    var diode=new createjs.Shape();
    diode.x=492;
    diode.y=137;
    diode.graphics.beginStroke("black").setStrokeStyle(1).moveTo(0,0).lineTo(-55,0).lineTo(-55,-30);
    diode.graphics.beginStroke("black").setStrokeStyle(2).moveTo(-55,-30).lineTo(-45,-30).lineTo(-55,-45).lineTo(-65,-30).lineTo(-55,-30).moveTo(-55,-45).lineTo(-63,-45).lineTo(-47,-45).beginStroke("red").setStrokeStyle(1).moveTo(-55,-46).lineTo(-55,-120);
    stage.addChild(diode);

    var diodetext= new createjs.Text("δίοδος", "13px Arial", "black");
    diodetext.x = 379;
    diodetext.y = 80;
    stage.addChild(diodetext);



    rswitch_off.visible = true;
    rswitch_on.visible = false;


    stage.addChild(lamp_on1);
    stage.addChild(lamp_off1);
    lamp_on1.visible = false;

    //---------------------------------------------------------------------

    stage.addChild(Vplustext);


    createjs.Ticker.addEventListener("tick", handleTick);
    function handleTick(event) {
        // Actions carried out each tick (aka frame)

        console.log("c= " + c);
        stage.update();
        c++;

        if (c > 10) {

            createjs.Ticker.removeEventListener("tick", handleTick);
        }

    }



}





stage.update();

